function handleResponse()
{       
  var resFrame = parent.frames[parent.ROOT_VIEW_ID + "_RESPONSEFRAME"];
  window.status = "handle Response called." + resFrame.location.href;
  if(checkIfBlankPage(resFrame))
  {
    return;
  }
  if(!resFrame.ROOT_VIEW_ID)
  {
    handleErrorIfPresent(resFrame);
    return;
  }


  var pd = parent.document;
  var rfd = resFrame.document;   
  var rootId = resFrame.ROOT_VIEW_ID;       
 
 //Putting a fix without proper understanding!!!
  if((stateData[rootId]["_PV"] == null)
      && (rootId != ROOT_VIEW_ID))
  {
     return;
  }
  
  if(rfd.getElementById(rootId + "_CT1") != null)
  {//Same view to be shown. So no need for updation.
    return; 
  }
  if(useSubRequest)
  {
    updateOldViews();
  } 
  updateViewFromReq(rootId,resFrame);

  //updateOldViews(elMap);
  if(useSubRequest)
  {
  var viewsToImp = resFrame["VIEWSTOIMP"];
  for(var i in viewsToImp)
  {
    addViews(viewsToImp[i],document);
  }
  }
  execOnLoadScripts(resFrame);
  updateParentCookie();
}

function checkIfBlankPage(resFrame)
{
   if((resFrame.location.href == "about:blank")
      || (resFrame.location.href.indexOf("blank.html") > 0) 
      || (resFrame.location.href.indexOf("empty.html") > 0))
   {
     return true;
   }
   if(resFrame["ISEMPTYRESPONSE"])
   {
     return true;
   }
   return false;
}



 
  function updateViewFromReq(rootId,respFrame)
  {
      var el = respFrame.document.getElementById(rootId + "_CT");
      if(!el)
      {
	 alert("The corresponding html content for " + rootId
                + " not  present in RESPONSEFRAME window.");
	 return;
      }  
      removeTags(el,"script");
      var clonedEl = createElementDiv(rootId + "_CT");

      var toReplaceViewId = rootId;
      if(stateData[rootId]["_PV"] == null)
      {
         toReplaceViewId = ROOT_VIEW_ID;         
      }
      
      var holderEL = document.getElementById(toReplaceViewId + "_CT");
      if(!holderEL)
      {
	 alert("The corresponding html content for " + rootId + " not present in parent window.");
	 return;
      }
      clonedEl.innerHTML = el.innerHTML;
      removeTags(clonedEl,"script");
      holderEL.parentNode.replaceChild(clonedEl,holderEL);
      if((toReplaceViewId == ROOT_VIEW_ID) && (rootId != toReplaceViewId))
      {
        ROOT_VIEW_ID = rootId;
      }
  }

function handleErrorIfPresent(resFrame)
{
  if((resFrame.ROOT_VIEW_ID) && (!resFrame.ERROR_MSG))
  {
     return false;
  }
  
  if(resFrame.ERROR_MSG)
  {      
      alert(resFrame.ERROR_MSG);
  }
  else
  {
     alert("Error has occurred during response.Please view the error window for more details");
  }  
  
  if(resFrame.FORWARD_URL)
  {
     parent.location.href= CONTEXT_PATH + "/" + resFrame.FORWARD_URL;
  }
  else
  { 
      var errorWindow = window.open("about:blank","ERROR_WINDOW","resizable=yes");
      errorWindow.document.writeln(resFrame.document.body.innerHTML);

      var doc = errorWindow.document;
      var e = doc.createElement("link");
      e.href =  THEME_DIR + "/styles/style.css";
      e.rel="stylesheet";
      e.type="text/css";
      doc.getElementsByTagName("head")[0].appendChild(e); 
      includeScriptInDoc(doc,CONTEXT_PATH + "/components/javascript/error.js");
  }
  return true;
}

function updateOldViews()
{
  var rootEl = document.getElementById(ROOT_VIEW_ID + "_CT");
  removeTags(rootEl,"script");
  for(var name in stateData)
  {
     var holderEL = document.getElementById(name + "_CT");
     if(holderEL != null)
     {
         oldViews[name] = holderEL;
     }
  }
}


function removeFromParent(name,childViewEl)
{
    if(childViewEl.parentNode != null)
    {
      childViewEl.parentNode.replaceChild(createElementDiv(name + "_CT1"),childViewEl );
      oldViews[name] = childViewEl;
    }
 
}

function createElementDiv(elName)
{
   var el = document.createElement("div");
   el.id=elName;
   el.className="uicomponent";   
   return el;
}


function importView(uniqueId,parentViewId,parentDCA,resFrame)
{
  if(resFrame["VIEWSTOIMP"] == null)
  {
    resFrame.VIEWSTOIMP = new Array(0);
  }
  updateExistingView(uniqueId,parentViewId,parentDCA);
  resFrame.VIEWSTOIMP.push(uniqueId);
}


function removeTags(el,tagName)
{
   var scriptTags = el.getElementsByTagName(tagName);
   var scriptTagArr = new Array();
   for(var sCursor = 0;sCursor < scriptTags.length; sCursor++)
   {   
       scriptTagArr[sCursor] = scriptTags[sCursor];
   }
   for(var sCursor = 0;sCursor < scriptTagArr.length; sCursor++)
   {   
       scriptTagArr[sCursor].parentNode.removeChild(scriptTagArr[sCursor]);
   }
   //showMsgInWindow("Script",str);
}

function addViews(uniqueId,doc)
{       
   var el = doc.getElementById(uniqueId + "_CT1");
   if(el == null)
   {
      alert("The html content for " + uniqueId + " is not present in response");
      return;
   }

   if(oldViews[uniqueId] == null)
   {
      alert("The html content for " + uniqueId + " is not present in response");
      return;   
   }
   
   el.parentNode.replaceChild(processStoredViewEl(uniqueId,oldViews[uniqueId]),el);
}


function processStoredViewEl(uniqueId,viewEl)
{
   removeFromParent(uniqueId,   viewEl);

   var divTags =  viewEl.getElementsByTagName("div");
   var tempDivTags = new Array();
   for(var dCursor = 0;dCursor < divTags.length; dCursor++)
   {   
      tempDivTags.push(divTags[dCursor]);
   }
 
   divTags = tempDivTags;   
   for(var dCursor = 0;dCursor < divTags.length; dCursor++)
   {   
       if("uicomponent" == divTags[dCursor]["className"])
       {
           var childUniqId = divTags[dCursor]["id"];
           childUniqId = childUniqId.substring(0,childUniqId.length - "_CT1".length);
           if(oldViews[childUniqId] == null)
           {
              alert("The html content for " + childUniqId + " is not present in oldViews");
           }
           var child = processStoredViewEl(childUniqId,oldViews[childUniqId]);
           divTags[dCursor].parentNode.replaceChild(child,divTags[dCursor]);
       }
   }
   return viewEl;
}

function getViewIfReused(divToCheck)
{
   var vId = divToCheck.id;
   var ckLength = "_CT1".length;
   var vLen = -1;
   if((vId == null) || ((vLen = vId.length) < (ckLength +1)))
   {
     return null;
   }
   if(vId.indexOf("_CT1",vLen - ckLength -1) == -1)
   {
      return null;
   }
   vId = vId.substring(0,vLen - ckLength);
   return vId;
}

function updateParentCookie()
{
  var urlStr = parent.location.href;
  var index = urlStr.indexOf("STATE_ID");
  if(index < -1)
  {
     return;
  }
  var newIndex = urlStr.indexOf("/","STATE_ID".length + index + 1);
  var path = CONTEXT_PATH + "/" + urlStr.substring(index,newIndex);
  var curDate = new Date();
  updateStateCookie(path,curDate.getTime(),null);
}

function addToOnLoadScripts(script,win)
{
   win.postInvokeScripts.push(script);     
}

function execOnLoadScripts(win)
{
   for(var i = 0; i < win.postInvokeScripts.length; i++)
   {
     try
     {
        eval(win.postInvokeScripts[i]);
     }
     catch(e)
     {
       if(showError)
       { 
           alert("Exception occurred when executing post invoke script " + win.postInvokeScripts[i]
               + " Msg : " + e.message);
       }
     }
   }
}
